
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                        ;
;          EXAMPLE 2 - EXPENSIVE LED BLINKER                             ;
;                                                                        ;
;          THIS ROUTINE BLINKS AN LED                                    ;
;                                                                        ;
;          LABEL A WRITES 01 HEX TO THE BUS - TURNS ON LED               ;
;                                                                        ;
;          LABEL B WRITES 00 HEX TO THE BUS - TURNS OFF LED              ;
;                                                                        ;
;          LABEL C JUMPS TO THE BEGINNING LABEL A                        ;
;                                                                        ;
;          SUBROUTING KILLTIME DECREMENTS 2 REGISTERS TO CREATE A DELAY  ;
;                                                                        ;
;                                                                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

           .ORG 000H
A          MOV  A,#00000001B     ;WRITE A BINARY 00000001 TO THE DATA BUS
           OUTL BUS,A            ;TURN ON TRANSISTOR AND LED

           CALL KILLTIME         ;KILL SOME TIME

B          MOV  A,#00000000B     ;WRITE A BINARY 00000000 TO DATA BUS
           OUTL BUS,A            ;TURN OFF TRANSISTOR AND LED

           CALL KILLTIME         ;KILL SOME TIME

C          JMP  A                ;GO DO IT ALL AGAIN

KILLTIME   MOV  R0,#0FFH         ;LOAD REGISTER R0 WITH FF HEX

INNERLOOP  MOV  R1,#0FFH         ;LOAD REGISTER R1 WITH FF HEX
           DJNZ R1,$             ;DECREMENT R1 TO 00

           DJNZ R0,INNERLOOP     ;DECREMENT R0 - IF R0 NOT EQUAL 0 THEN DO INNERLOOP

           RET                   ;DONE KILLING TIME
           .END
