
;874X PROGRAMMER 8-31-90
;
;6-5-91    ADDED  CODE TO FIX PROBLEM WITH PROGRAM AREA
;;;;;;;;;;;;;8749 INTERNAL MEMORY LOCATIONS

RECBYTE    .EQU 32

ADDHIGH    .EQU 33
ADDLOW     .EQU 34

HICOUNT    .EQU 35
LOWCOUNT   .EQU 36

ACTUALHI   .EQU 37
ACTUALLO   .EQU 38
DATABYTE   .EQU 39
VERBYTE    .EQU 40

; SERIAL RATES ARE WITH A 10MHZ CLOCK
;    1200 BPS  = 7FH
;    2400 BPS  = 3FH

HALFBITDLY .EQU 3FH
;HALFBITDLY .EQU 7FH
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    P1 BIT ASSIGNMENTS                             ;
;                                                   ;
;     P10  BIT 0 = SERIAL OUT                       ;
;     P11  BIT 1 = MAIN POWER FOR DUP - ACTIVE LOW  ;
;     P12  BIT 2 = Vdd FOR DUP LOW=21 V HIGH=5V     ;
;     P13  BIT 3 = PROGRAM PULSE   ACTIVE LOW       ;
;     P14  BIT 4 = T0 (DUP)                         ;
;     P15  BIT 5 = RESET (DUP)                      ;
;     P16  BIT 6 = ALE (DUP) INPUT                  ;
;     P17  BIT 7 = EA CONTROL  HIGH=5V  LOW=18V     ;
;   DUP = DEVICE BEING PROGRAMMED                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    P2 BIT ASSIGNMENTS                             ;
;                                                   ;
;     P20  BIT 0 = A8 FOR DUP                       ;
;     P21  BIT 1 = A9 FOR DUP                       ;
;     P22  BIT 2 = A10 FOR DUP                      ;
;     P23  BIT 3 =                                  ;
;     P24  BIT 4 =                                  ;
;     P25  BIT 5 =                                  ;
;     P26  BIT 6 =                                  ;
;     P27  BIT 7 =                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;;;;;;;;;;;;;
           ;MAIN ROUTINE
           ;;;;;;;;;;;;;
           .ORG 0
BEGIN      DIS  I
           CALL VERIFYMODE

READY      CALL SERIALIN         ;LOOK FOR INPUT FROM BASIC
           MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0            ;LOOK FOR (T)
           ADD  A,#0ACH
           JNZ  READY            ;TERMINAL NOT READY YET..GO BACK

POLL       MOV  R0,#RECBYTE
           MOV  A,#50H           ;P FOR READY AT POLL
           MOV  @R0,A
           CALL BYTEOUT          ;TELL TERMINAL YOU ARE READY FOR INPUT

BLANKMENU  CALL SERIALIN         ;LOOK FOR INPUT FROM TERMINAL
           MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0            ;LOOK FOR (B) FOR BLANK CHECK
           ADD  A,#0BEH
           JZ   BLANKTEST        ;DO BLANKTEST

READMENU   MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0            ;LOOK FOR (R) FOR READ DUP
           ADD  A,#0AEH
           JZ   READDUP          ;DO DUP READ

PROGRMMENU MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0            ;LOOK FOR (P) FOR PROGRAM DUP
           ADD  A,#0B0H
           JZ   PROGRAMDUP       ;DO DUP PROGRAM

           JMP  POLL

BLANKTEST  CALL SETCOUNT         ;GET HIGH AND LOW ADDRESS FROM TERMINAL
           CALL ADDINIT          ;INITIALIZE THE ADDRESS TO 000H
           ANL  P1,#11111101B    ;TURN ON MAIN POWER TO DUP
           CALL LONGWAIT
           ANL  P1,#01111101B    ;BRING EA TO 18 VOLTS
TESTING    CALL ADDOUT           ;PUT OUT THE ADDRESS AND THEN INCREMENT IT - GET THE DATA TOO
           MOV  R1,#DATABYTE     ;POINT TO THE BYTE JUST READ
           MOV  A,@R1            ;LOAD A WITH THE BYTE JUST READ
           JNZ  BLANKERROR       ;CHECK THE BYTE FOR A ZERO
           MOV  R0,#ADDLOW       ;POINT TO ADDLOW
           MOV  A,@R0            ;LOAD A WITH ADDLOW VALUE
           CPL  A                ;COMPLEMENT THE ADDLOW VALUE
           MOV  R0,#LOWCOUNT     ;POINT TO LOWCOUNT VALUE
           ADD  A,@R0            ;ADD LOWCOUNT TO ADDLOW
           CPL  A                ;COMPLEMENT THE SUM
           JNZ  TESTING          ;IF NOT ZERO, THEN NO NEED TO CHECK HIADDRESS
           MOV  R0,#ADDHIGH      ;POINT TO ADDHIGH VALUE
           MOV  A,@R0            ;LOAD A WITH ADDHIGH VALUE
           CPL  A                ;COMPLEMENT THE ADDHIGH VALUE
           MOV  R0,#HICOUNT      ;POINT TO HICOUNT VALUE
           ADD  A,@R0            ;ADD HICOUNT AND ADDHIGH VALUE
           CPL  A                ;COMPLEMENT THE SUM
           JZ   BLANKOK          ;IF HI COUNT IS ALSO ZERO THEN DONE
           JMP  TESTING          ;NOT DONE SO GO BACK

BLANKOK    ORL  P1,#11111111B
           ANL  P1,#11011111B
           MOV  R0,#RECBYTE
           MOV  A,#42H           ;SEND A 'B' FOR PART IS BLANK
           MOV  @R0,A
           CALL BYTEOUT
           JMP  POLL

BLANKERROR ORL  P1,#11111111B
           ANL  P1,#11011111B
           MOV  A,#45H           ;SEND AN 'E' FOR BLANK ERROR
           MOV  R0,#RECBYTE
           MOV  @R0,A
           CALL BYTEOUT
           JMP  POLL

READDUP    CALL SETCOUNT
           CALL ADDINIT          ;INITIALIZE THE ADDRESS TO 000H
           ANL  P1,#11111101B    ;TURN ON MAIN POWER TO DUP
           CALL LONGWAIT         ;WAIT FOR TERMINAL PROGRAM TO GO READY
           ANL  P1,#01111111B    ;BRING EA TO 18 VOLTS
READING    CALL ADDOUT           ;PUT OUT THE ADDRESS AND THEN INCREMENT IT
           MOV  R1,#DATABYTE     ;POINT R1 TO BYTE JUST READ
           MOV  A,@R1            ;LOAD A WITH BYTE JUST READ
           MOV  R0,#RECBYTE      ;POINT R0 TO RECBYTE
           MOV  @R0,A            ;LOAD RECBYTE WITH BYTE JUST READ
           CALL BYTEOUT          ;PUT BYTE OUT
           MOV  R0,#ADDLOW       ;POINT R0 TO ADDLOW
           MOV  A,@R0            ;LOAD A WITH ADDLOW VALUE
           CPL  A                ;COMPLEMENT THE ADDLOW VALUE
           MOV  R0,#LOWCOUNT     ;POINT TO LOWCOUNT VALUE
           ADD  A,@R0            ;ADD LOWCOUNT TO ADDLOW
           CPL  A                ;COMPLEMENT THE SUM
           JNZ  READING          ;IF NOT ZERO, THEN NO NEED TO CHECK HIADDRESS
           MOV  R0,#ADDHIGH      ;POINT TO ADDHIGH VALUE
           MOV  A,@R0            ;LOAD A WITH ADDHIGH VALUE
           CPL  A                ;COMPLEMENT THE ADDHIGH VALUE
           MOV  R0,#HICOUNT      ;POINT TO HICOUNT VALUE
           ADD  A,@R0            ;ADD HICOUNT AND ADDHIGH VALUE
           CPL  A                ;COMPLEMENT THE SUM
           JZ   READOK           ;IF HI COUNT IS ALSO ZERO THEN DONE
           JMP  READING          ;NOT DONE SO GO BACK

READOK     ORL  P1,#11111111B
           ANL  P1,#11011111B
           JMP  POLL

PROGRAMDUP CALL SETCOUNT         ;GET ADDRESS LIMITS
           CALL ADDINIT          ;INITIALIZE ADDRESS COUNTERS
           ANL  P1,#11111101B    ;TURN ON MAIN POWER TO DUP
           ANL  P1,#11101111B    ;TAKE T0 LOW TO PROGRAM MODE
           CALL LONGWAIT         ;WAIT FOR DUP TO RESET
           ANL  P1,#01111111B    ;BRING EA TO 18 VOLTS
WRITEIT    CALL PROGOUT          ;GO PROGRAM BYTE
           JF1  BYTEOK           ;DATA BYTE WAS 00 HEX
           MOV  R0,#VERBYTE      ;GET VERIFICATION BYTE
           MOV  A,@R0            ;LOAD VERIFICATION BYTE TO A
           JNZ  PROGERROR        ;IF NOT ZERO..PROGRAM ERROR
BYTEOK     ANL  P1,#11001111B    ;TAKE T0 AND RESET TO PROGRAM MODE
           MOV  R0,#ADDLOW       ;POINT TO LOW ADDRESS
           INC  @R0              ;INCREMENT LOW ADDRESS
           MOV  A,@R0            ;PUT LOW ADDRESS IN A
           CPL  A
           MOV  R0,#LOWCOUNT
           ADD  A,@R0
           CPL  A
           JNZ  WRITEIT          ;IF NOT ZERO DO NOTHING
           MOV  R0,#ADDHIGH      ;IT'S ZERO POINT TO HIGH ADDRESS
           INC  @R0              ;INCREMENT THE HIGH ADDRESS
           MOV  A,@R0            ;LOAD A WITH HIGH ADDRESS
           CPL  A
           MOV  R0,#HICOUNT      ;POINT TO HICOUNT VALUE
           ADD  A,@R0
           CPL  A
           JZ   PROGRAMOK        ;IF NOT ZERO, THEN NO NEED TO CHECK HIADDRESS
           JNZ  WRITEIT

PROGERROR  ORL  P1,#11111101B    ;FIXED 6-5-91
           ANL  P1,#11011111B
           MOVX A,@R0            ;ADDED 6-5-91
           ORL  P1,#11111111B
           MOV  A,#45H           ;SEND AN 'E' FOR PROGRAM ERROR
           MOV  R0,#RECBYTE
           MOV  @R0,A
           CALL BYTEOUT
           JMP  BLANKMENU

PROGRAMOK  ORL  P1,#11111101B    ;FIXED 6-5-91
           ANL  P1,#11011111B
           MOVX A,@R0            ;FLOAT THE BUS     ADDED 6-5-91
           MOV  A,#44H           ;SEND AN 'D' FOR PROGRAMING DONE
           MOV  R0,#RECBYTE
           MOV  @R0,A
           CALL BYTEOUT
           JMP  POLL

           .ORG 100H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        SUBROUTINES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BYTEOUT    CLR  F0
           CPL  F0               ;SET THE F0 FLAG
           MOV  R2,#1
           CALL MESOUT
           CLR  F0
           RET
           ;;;;;;;;;;;;;;;;;;;;;;;;
           ;XMIT MESSAGE SUBROUTINE
           ;;;;;;;;;;;;;;;;;;;;;;;;
MESOUT     JF0  RECEIVE          ;JUMP ON FLAG 0 = 1 TO INDICATE RECEIVE MODE
           MOV  A,R1             ;GET CURRENT BYTE FROM MESSAGE GOING OUT
           MOVP3 A,@A
           JMP  TRANSMIT
RECEIVE    MOV  R0,#RECBYTE      ;POINT TO CHARACTER BEING ECHOED
           MOV  A,@R0            ;GET ECHO CHARACTER
TRANSMIT   MOV  R5,A             ;LOAD BUFF WITH XMIT CHARACTER
           INC  R1               ;INCREMENT TO NEXT CHARACTER
           DEC  R2               ;DECREMENT THE MESSAGE BYTE COUNT
           MOV  R4,#0FFH         ;LOAD CHARACTER AVAILABLE REGISTER
           MOV  R3,#0            ;CLEAR R3 GOING IN
           ORL  P1,#00000001B    ;MARK THE LINE
           CALL SERIALCLK
           MOV  A,R2             ;LOOK FOR END OF MESSAGE
           JNZ  MESOUT
           RET
           ;;;;;;;;;;;;;;;;;;;
           ;SERIAL I/O ROUTINE
           ;;;;;;;;;;;;;;;;;;;
SERIALCLK  CALL BIT
           JC   BITON            ;IF CARRY IS SET THE BIT IS A ONE
           ANL  P1,#11111110B    ;NO CARRY XMIT A 0
           CALL HBIT             ;START THE CLOCK FOR THE 0
           CALL HBIT
           JMP  EXIT
BITON      ORL  P1,#00000001B    ;XMIT A 1
           CALL HBIT
           CALL HBIT
EXIT       DJNZ R0,SERIALCLK     ;DECREMENT THE NUMBER OF BITS TO XMIT
           RET                   ;GET OUT
BIT        MOV  A,R3             ;LOOK FOR CHAR AVAILABLE
           JZ   IDLE             ;NO CHARACTER....MARK THE LINE
           MOV  A,R5             ;GET BYTE TO BE SENT INTO PTOS
           RRC  A                ;ROTATE IT
           MOV  R5,A             ;SAVE ROTATED CHARACTER
           DEC  R3               ;DECREMENT THE BIT COUNT
           RET
IDLE       CLR  C                ;CLEAR CARRY
           MOV  A,R4             ;LOOK FOR FF HEX IN CHAR AVAILABLE
           JNZ  GOTONE           ;CHAR AVAILABLE
           CPL  C                ;SET CARRY TO CONTINUE TO MARK LINE
           RET
GOTONE     MOV  R3,#8            ;LOAD BIT COUNT OF 8
           MOV  R4,#0            ;CLEAR THE CHAR AVAILABLE REGISTER
           MOV  R0,#10           ;LOAD ACTUAL NUMBER OF BITS TO XMIT
           RET

           ;;;;;;;;;;;;;;
           ;XMIT BIT TIME
           ;;;;;;;;;;;;;;
HBIT       MOV  R6,#HALFBITDLY
           DJNZ R6,$
           RET
           ;;;;;;;;;;;;;
           ;SERIAL INPUT
           ;;;;;;;;;;;;;
SERIALIN   JNT0 $                ;LOOP UNTIL MARK
           JT0  $                ;LOOP UNTIL SPACE
           CALL HBIT             ;WAIT 1/2 BIT TIME
           JT0  SERIALIN
           MOV  R2,#9
BITIN      CALL HBIT
           CALL HBIT
           DJNZ R2,LOADBYTE
           MOV  R0,#RECBYTE
           MOV  @R0,A
BYTEIN     RET
LOADBYTE   CLR  C
           JNT0 ROTATE
           CPL  C
ROTATE     RRC  A
           JMP  BITIN

ADDINIT    SEL  RB1
           MOV  A,#0             ;LOAD A WITH 00
           MOV  R0,#ADDHIGH      ;POINT RB1 R0 TO ADDHIGH
           MOV  @R0,A            ;LOAD ADDHIGH WITH 00
           INC  R0               ;POINT RB1 R0 TO ADDLOW
           MOV  @R0,A            ;LOAD ADDLOW WITH 00
           SEL  RB0              ;SELECT RB0
           RET

ADDOUT     SEL  RB1              ;SELECT RB1
           MOV  R0,#ADDLOW       ;POINT TO LOW ADDRESS
           MOV  A,@R0            ;PUT LOW ADDRESS IN A
           OUTL BUS,A            ;PUT LOW ADDRESS OUT
           INC  @R0              ;INCREMENT LOW ADDRESS
           DEC  R0               ;POINT TO HIGH ADDRESS
           MOV  A,@R0            ;PUT HIGH ADDRESS IN A
           OUTL P2,A             ;PUT HIGH ADDRESS OUT
           MOV  R7,#20H          ;KILL 17 USEC MINIMUM
           DJNZ R7,$
           ORL  P1,#00110000B    ;LATCH LOW ADDRESS
           MOV  R7,#20H          ;KILL 17 USEC MINIMUM
           DJNZ R7,$
           INC  R0               ;POINT TO ADDLOW
GETITNOW   MOVX A,@R0            ;READ BYTE FROM DUP
           MOV  R1,#DATABYTE     ;POINT R1 TO DATABYTE
           MOV  @R1,A            ;STORE THE BYTE JUST READ
           ANL  P1,#01001101B    ;RESET THE ADDRESS LATCH
           MOV  A,@R0            ;PUT LOW ADDRESS IN A
           JNZ  NOROLL           ;IF NOT ZERO DO NOTHING
           DEC  R0               ;IT'S ZERO SO POINT TO HIGH ADDRESS
           INC  @R0              ;INCREMENT HIGH ADDRESS
NOROLL     SEL  RB0              ;GET OUT
           RET

PROGOUT    SEL  RB1              ;SELECT ALTERNATE REGISTER BANK
           MOV  R0,#ADDLOW       ;POINT TO LOW ADDRESS
           MOV  A,@R0            ;PUT LOW ADDRESS IN A
           OUTL BUS,A            ;PUT LOW ADDRESS OUT
           DEC  R0               ;POINT TO HIGH ADDRESS
           MOV  A,@R0            ;PUT HIGH ADDRESS IN A
           OUTL P2,A             ;PUT HIGH ADDRESS OUT
           MOV  R7,#20H          ;DELAY
           DJNZ R7,$
           ORL  P1,#00100000B    ;RAISE RESET TO LATCH ADDRESS
           MOV  R7,#20H          ;DELAY
           DJNZ R7,$
WRITEDATA  CALL DATAOUT          ;GO PUT DATA OUT TO PROGRAM
           MOV  R7,#20H          ;DELAY
           DJNZ R7,$
           JF1  ITISZERO         ;IF FLAG IS SET DO NOTHING
           ANL  P1,#11111011B    ;RAISE Vdd TO 21 VOLTS
           CALL HIGHFIFTY        ;PULSE IT
           ORL  P1,#00000100B    ;RESTORE Vdd TO 5 VOLTS
TWTDELAY   MOV  R7,#20H          ;DELAY
           DJNZ R7,$
           ORL  P1,#00010000B    ;TAKE T0 TO VERIFY MODE
TDODELAY   MOV  R7,#20H          ;DELAY
           DJNZ R7,$
VERIFY     MOVX A,@R0            ;GET THE JUST PROGRAMMED BYTE
           MOV  R0,#DATABYTE     ;POINT TO DATABYTE LOCATION
           CPL  A                ;COMPLEMENT A
           ADD  A,@R0            ;ADD A WITH PROGRAMMED BYTE
           CPL  A                ;COMPLEMENT A
           MOV  R0,#VERBYTE      ;SAVE RESULT FOR VERIFICATION
           MOV  @R0,A
ITISZERO   SEL  RB0              ;GET OUT
           RET

           .ORG 200H
DATAOUT
           CLR  F1               ;INITIALIZE FLAG 1
           MOV  R0,#RECBYTE      ;POINT TO SERIAL DATA BYTE
           MOV  A,#53H           ;SEND S TO TERMINAL
           MOV  @R0,A
           CALL BYTEOUT          ;TELL TERMINAL TO SEND NEXT DATA BYTE

           CALL SERIALIN         ;LOOK FOR INPUT FROM TERMINAL
           MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0            ;PUT RECEIVED DATA IN A
           JZ   DATAZERO         ;DO NOTHING IF DATA IS 00 HEX
           OUTL BUS,A            ;PUT DATA OUT
           MOV  R0,#DATABYTE     ;POINT TO DATABYTE LOCATION
           MOV  @R0,A            ;SAVE THE DATA FOR VERIFY PROCESS
           RET
DATAZERO   CPL  F1               ;SET FLAG 1 TO SIGNIFY 00 HEX DATA
           RET


SETCOUNT   CALL SERIALIN
           MOV  R0,#RECBYTE      ;POINT TO RECEIVED BYTE
           MOV  A,@R0
           MOV  R0,#HICOUNT      ;SET BYTE COUNT HIGH
           MOV  @R0,A

           CALL SERIALIN
           MOV  R0,#RECBYTE
           MOV  A,@R0
           MOV  R0,#LOWCOUNT     ;SET BYTE COUNT LOW
           MOV  @R0,A
           RET

VERIFYMODE ORL  P1,#11111111B    ;SET UP FOR VERIFY MODE
           ANL  P1,#11011111B    ;TAKE DUP RESET
           RET

HIGHFIFTY  ANL  P1,#11110111B
           MOV  R7,#42H
NEXTLOOP   MOV  R6,#0FFH
           DJNZ R6,$
           DJNZ R7,NEXTLOOP
           ORL  P1,#00001000B
           RET

LONGWAIT   MOV  R7,#0FFH         ;WAIT FOR TERMINAL PROGRAM TO GO READY
LONG1      MOV  R6,#0FFH
           DJNZ R6,$
           DJNZ R7,LONG1
           RET
           .END
